using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using Microsoft.Web.Services3;

namespace PrototypAssertion
{
    public class Validator
    {
        private PolicyMappingManager mappingManager;

        public Validator(PolicyMappingManager pmm)
        {
            mappingManager = pmm;
        }

        public bool IsValid(SoapEnvelope envelope)
        {
            string[] uriAndPort = GetUriAndPort(envelope);
            string uri = uriAndPort[0];
            string port = uriAndPort[1];

            mappingManager.GetMapping(uri, port);

            return true;            
        }

        string[] GetUriAndPort(SoapEnvelope envelope)
        {
            string[] uriAndPort = new string[2];

            XmlReader headerReader = envelope.GetHeaderReader();
            while (headerReader.Read())
            {
                // Read URI
                if (headerReader.NodeType == XmlNodeType.Element && headerReader.LocalName == "To" && headerReader.NamespaceURI == "http://schemas.xmlsoap.org/ws/2004/08/addressing")
                {
                    headerReader.Read();
                    headerReader.MoveToContent();
                    if (headerReader.HasValue)
                    {
                        uriAndPort[0] = headerReader.Value;
                        if (uriAndPort[1] != null) break;
                    }
                }

                // Read port
                if (headerReader.NodeType == XmlNodeType.Element && headerReader.LocalName == "Action" && headerReader.NamespaceURI == "http://schemas.xmlsoap.org/ws/2004/08/addressing")
                {
                    headerReader.Read();
                    headerReader.MoveToContent();
                    if (headerReader.HasValue)
                    {
                        uriAndPort[1] = headerReader.Value;
                        if (uriAndPort[0] != null) break;
                    }
                }
            }
            headerReader.Close();

            return uriAndPort;
        }
    }
}
