using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using InputValidator;

public partial class _Correctness : System.Web.UI.Page 
{
    string xmlsavepath;
    string configsavepath;
    bool validUpload;


    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        // Make sure that the user has supplied the necessary information
        if (xmlupload.HasFile && configupload.HasFile && TextBox1.Text != "")
        {
            
            HttpPostedFile xmlfile = xmlupload.PostedFile;
            HttpPostedFile configfile = configupload.PostedFile;

            if (xmlfile.ContentType == "text/xml"
              && configfile.ContentType == "application/xml")
            {
                xmlsavepath = xmlupload.PostedFile.FileName;
                configsavepath = configupload.PostedFile.FileName;
                validUpload = true;
            }
            else 
            {
                txtoutput.InnerHtml += "<h3>Upload failed</h3><p>Verify that"
              + "your files has .xml and .config extensiions respectively.</p>";
            }

        }
        else
        {
            txtoutput.InnerHtml += "<h3>Upload failed</h3><p>You must upload a"
          + "config file and an XML Schema file. Also remember to provide"
          + "a policy section name.</p>";
        }

        // Print the results from the XML file
        if(validUpload)
        {
            XmlTextReader xmlreader = new XmlTextReader(xmlsavepath);
            XmlTextReader configreader = new XmlTextReader(configsavepath);
            XmlDocument xmldoc = new XmlDocument();
            XmlDocument configdoc = new XmlDocument();
            xmldoc.Load(xmlreader);
            configdoc.Load(configreader);
            xmlreader.Close();
            configreader.Close();
            
            CorrectnessVerificator verificator =
              new CorrectnessVerificator(xmldoc, configdoc, TextBox1.Text);
            XmlDocument doc = verificator.Verify();

            XmlNamespaceManager xmlnsm = new XmlNamespaceManager(doc.NameTable);
            xmlnsm.AddNamespace("item", "http://www.item.ntnu.no/ws");

            XmlNodeList webservices =
              doc.SelectNodes("/item:definitions/item:webservice", xmlnsm);
            XmlNodeList validMessages;
            XmlNodeList invalidMessages;

            validationoutput.InnerHtml = "";
   
            validationoutput.InnerHtml += "<br/><br/><div style=font-size:20pt;"
              + "font-family:times>Validation Results</div><p/>";
            foreach (XmlNode node in webservices)
            {
                
                XmlNodeList ports = node.SelectNodes("item:port", xmlnsm);

                foreach (XmlNode port in ports)
                {
                    validMessages = port.SelectNodes(
                      "./item:validMessages/item:message", xmlnsm);
                    invalidMessages = port.SelectNodes(
                      "./item:invalidMessages/item:message", xmlnsm);

                    validationoutput.InnerHtml += "<tr><td colspan=3"
                  + " style=font-size:18pt>Port: " + port.Attributes["name"].Value
                  + "</td></tr>";

                    if (validMessages.Count > 0)
                      validationoutput.InnerHtml += "<tr><td colspan=3><b>"
                        + "Specified as valid messages in the testset:</b></td>";

                    foreach (XmlNode valid in validMessages)
                    {

                        validationoutput.InnerHtml += "<tr>";
                        if (valid.SelectSingleNode(
                          @"./@item:status", xmlnsm).Value == "valid")
                        {

                            validationoutput.InnerHtml += @"<td><img src="
                          + "img/green-circle.jpg width=20></td><td></td>"
                          + "<td style='font-family:courier; font-size: 0.8em'>"
                          + Server.HtmlEncode(valid.InnerXml) + "</td>";
                        }
                        else
                        {
                            validationoutput.InnerHtml += @"<td><img src=img/"
                              + "red-square.jpg width=20></td><td style='color: "
                              + "red; font-size: 1.4em; font-weight: bold;'>!</td>"
                              + "<td style='font-family: courier; font-size: 0.8em'>"
                                + Server.HtmlEncode(valid.InnerXml) + "</td>";

                        }

                    }

                    if (invalidMessages.Count > 0)
                        validationoutput.InnerHtml += "<tr><td colspan=3></br><b>"
                        + "Specified as invalid messages in the testset:</b>"
                        + "</td></tr>";

                    foreach (XmlNode valid in invalidMessages)
                    {

                        validationoutput.InnerHtml += "<tr>";
                        if (valid.SelectSingleNode(
                          @"./@item:status", xmlnsm).Value == "valid")
                        {
                            validationoutput.InnerHtml += @"<td><img src=img/green"
                              + "-circle.jpg width=20></td><td style='color: red;"
                              + "font-size: 1.4em; font-weight: bold;''>!</td> <td"
                              + " style='font-family: courier; font-size: 0.8em'>"
                              + Server.HtmlEncode(valid.InnerXml) + "</td>";
                        }
                        else
                        {
                            validationoutput.InnerHtml += @"<td><img src=img/red-"
                            + "square.jpg width=20></td><td></td><td style='font-"
                            + "family: courier;font-size: 0.8em'>"
                            + Server.HtmlEncode(valid.InnerXml) + "</td>";
                        }
                        validationoutput.InnerHtml += "</tr>";
                    }

                    validationoutput.InnerHtml +=
                      "<tr><td colspan=3>&nbsp;</td></tr>";

                }//foreach port in port
            }//foreach node in webservices

        }//if validupload
        else
        {
            txtoutput.InnerHtml = "<h3>Validation failed</h3>";
        }
    }
}

