using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using InputValidator;

public partial class _Coverage : System.Web.UI.Page 
{
    string configsavepath;
    bool validUpload;


    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        // Make sure that the user has supplied the necessary information
        if (configupload.HasFile && TextBox1.Text != "")
        {
            
            HttpPostedFile configfile = configupload.PostedFile;

            if (configfile.ContentType == "application/xml")
            {
                configsavepath = configupload.PostedFile.FileName;
                validUpload = true;
            }
            else 
            {
                txtoutput.InnerHtml += "<h3>Upload failed</h3>"
                  + "<p>Verify that your file has .config extension.</p>";
            }

        }
        else
        {
            txtoutput.InnerHtml += "<h3>Upload failed</h3><p>You must upload"
              + "a config file. Also remember to provide a policy section name.</p>";
        }

        // Display the contents of the XML file
        if(validUpload)
        {
            txtoutput.InnerHtml = "";

            XmlTextReader configreader = new XmlTextReader(configsavepath);
            XmlDocument configdoc = new XmlDocument();
            configdoc.Load(configreader);
            configreader.Close();
            
            CoverageVerificator verificator =
              new CoverageVerificator(configdoc, TextBox1.Text);
            XmlDocument doc = verificator.Verify();

            XmlNamespaceManager xmlnsm = 
              new XmlNamespaceManager(configdoc.NameTable);
            xmlnsm.AddNamespace("item", "http://www.item.ntnu.no/ws");

            XmlNodeList webservices = doc.SelectNodes(
              "/item:mapping/item:webservice", xmlnsm);

            validationoutput.InnerHtml = "";

            validationoutput.InnerHtml += "<br/><br/><div style=font-size:20pt;"
              + "font-family:times>Validation Results</div><p/>";
            foreach (XmlNode webservice in webservices)
            {
              validationoutput.InnerHtml += "<h2>Web Service</h2>";

              XmlNodeList uris = webservice.SelectNodes("item:uris/item:uri",
                xmlnsm);
              foreach (XmlNode uri in uris)
              {
                validationoutput.InnerHtml += uri.InnerText + "</br>";
              }
              validationoutput.InnerHtml += "</br></br>";

              XmlNodeList ports = webservice.SelectNodes("item:ports/item:port",
                xmlnsm);

                foreach (XmlNode port in ports)
                {
                  validationoutput.InnerHtml += "<font size=3>Port: "
                    + port.Attributes["name"].Value + "</font></br>";

                  if (port.Attributes["item:protected"].Value == "false")
                  {
                    validationoutput.InnerHtml += "<font size=3 style=\"color:red\">"
                      + "<b>This port is not protected</b></font>";
                  }
                  else
                  {
                    validationoutput.InnerHtml += "<table border=1><tr><th>Parameter"
                      + "</th><th>Protected?</th><th>WSDL?</th><th>Schema</th></tr>";

                    XmlNodeList parameters = port.SelectNodes("item:param", xmlnsm);

                    foreach (XmlNode param in parameters)
                    {
                      validationoutput.InnerHtml += "<tr><td>"
                        + param.Attributes["name"].Value
                        + "</td>";
                      if (param.Attributes["item:protected"].Value == "false")
                      {
                        validationoutput.InnerHtml +=
                          "<td><font style=\"color:red\"><b>NO</b></font></td>";

                        validationoutput.InnerHtml += "<td>&nbsp;</td><td>&nbsp;</td>";
                      }
                      else
                      {
                        validationoutput.InnerHtml += "<td>yes</td>";

                        if (param.Attributes["item:wsdl"].Value == "true")
                        {
                          validationoutput.InnerHtml += "<td>yes</td>";
                        }
                        else
                        {
                          validationoutput.InnerHtml += "<td>no</td>";
                        }

                        validationoutput.InnerHtml += "<td>"
                          + param.Attributes["item:schema"].Value
                          + "&nbsp;</td>";
                      }



                      validationoutput.InnerHtml += "</tr>";
                    }
                    validationoutput.InnerHtml += "</table></br>";
                  }
                }//foreach port in port
            }//foreach webservice in webservices

        }//if validupload
        else
        {
            txtoutput.InnerHtml = "<h3>Validation failed</h3>";
        }
    }
}

